use P4::test;
use P4::TM { DATA_DIR => 'self' };
use Data::Dumper;
use File::Copy;
use File::Copy::Recursive 'dircopy';

P4::TM::add_mask_func sub {
  s/[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-z]{4}-[0-9a-z]{4}-[0-9a-z]{12}/UUIDMASK/gi;
  $_
};
`p4 user -o  sampleExtensionsUser | p4 user -i -f`;
# We use the internal Swarm instance in lieu of setting one up just for this test.
`p4 counter -f change 1608657`;
$P4CONFIG{ P4USER } = 'jgibson';

dircopy $script_abspath =~ s/\.t$//r . '/*', 'swarmExt';
tm `p4 extension --package swarmExt`;
tm `p4 extension --install swarmExt.p4-extension -y`;
$stdin = `p4 extension --configure ExampleInc::swarmExt -o`;
$stdin =~ s#http://swarm.example.com#https://swarm.perforce.com/#g;
$stdin =~ s/Swarm user password or Helix Core Server ticket/asdasdf/g;
$stdin =~ s/Swarm user name/perforce/g;
tm `p4 extension --configure ExampleInc::swarmExt -i`;

$stdin = `p4 extension --configure ExampleInc::swarmExt --name swarmExt-instance -o`;
$stdin =~ s/ext user/$ENV{P4USER}/g;
`p4 extension --configure ExampleInc::swarmExt --name swarmExt-instance -i`;

`p4 client -o | p4 client -i`;
write_file 'a', "b\n";
`p4 add -t binary+T a`;
tm `p4 submit -d foo`;

`p4 --field Description=foo change -o | p4 change -i`;
tm `p4 shelve -f -c 1608660`;

#diag 'stdout:  '.Dumper $server->getSTDOUT;
#diag 'stderr:  '.Dumper $server->getSTDERR;

__DATA__
[[17,18,23,32,35],
[
  'p4 extension --package swarmExt',
  'Extension packaged successfully.
',
  0,
  'p4 extension --install swarmExt.p4-extension -y',
  'Extension \'ExampleInc::swarmExt\' version \'2019.1\' installed successfully.
',
  0,
  'p4 extension --configure ExampleInc::swarmExt -i',
  'Extension config swarmExt saved.
',
  0,
  'p4 submit -d foo',
  '
Submitting change 1608659.
Locking 1 files ...
add //depot/a#1
Change 1608659 submitted.
',
  0,
  'p4 shelve -f -c 1608660',
  '
Shelving files for change 1608660.
No files to shelve.
swarmExt/UUIDMASK/2019.1 GA:  Review ID: 1608065, state: approved
changes: 1, 1606790, 2, 1608066, 3, 1608585, 4, 1608613, 5, 1608655, 6, 1608660
',
  1
]
]
