use P4::test;
use P4::TM { DATA_DIR => 'self' };
use Data::Dumper;
use File::Copy;
use Text::Diff;
use File::Copy::Recursive 'dircopy';


dircopy $script_abspath =~ s/\.t$//r . '/*', 'ValidateFieldSize';
cp 'foo/manifest.lua', 'ValidateFieldSize';
`p4 extension --package ValidateFieldSize`;
`p4 extension --install ValidateFieldSize.p4-extension -y`;

tm `p4 extension --configure ExampleInc::validate-fieldsize -o | p4 extension --configure ExampleInc::validate-fieldsize -i`;

$stdin =  `p4 extension --configure ExampleInc::validate-fieldsize --name=nm1 -o`;
$stdin =~ s/formField:.*\n.*/formField: Description/g;
$stdin =~ s/formType:.*\n.*/formType: change/g;
$stdin =~ s/minSize:.*\n.*/minSize: 10/g;
tm `p4 extension --configure ExampleInc::validate-fieldsize --name=nm1 -i`;

`p4 client -o | p4 client -i`;
write_file 'somefile1.txt', 'some content for file1';
`p4 add ./somefile1.txt`;
$stdin =  `p4 change -o`;
$stdin =~ s/Description:.*\n.*/Description: short des/g;
tm `p4 change -i`;

tm grep { /Perforce server error:/ ... /Perforce server info/ } read_file "$server->{serverRoot}/track.log";

__DATA__
[[14,20,27,29],
[
  'p4 extension --configure ExampleInc::validate-fieldsize -o | p4 extension --configure ExampleInc::validate-fieldsize -i',
  '
Extension config validate-fieldsize saved.
User sampleExtensionsUser doesn\'t exist (Extension owner:user).
',
  0,
  'p4 extension --configure ExampleInc::validate-fieldsize --name=nm1 -i',
  'Extension config nm1 saved.
',
  0,
  'p4 change -i',
  '
Error in change specification.
\'nm1\' validation failed: Field \'Description\' minimum size is 10, \'short des\' is too short.
',
  1,
  'grep { /Perforce server error:/ ... /Perforce server info/ } read_file "SERVER_ROOT_MASK/track.log"',
  '
Perforce server error:
	\'nm1\' validation failed: Field \'Description\' minimum size is 10, \'short des\' is too short.: Field \'Description\' minimum size is 10, \'short des\' is too short.
',
  1
]
]
